"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
var cacheName = 'useHTTPcache';
var getCache = function () {
    try {
        return JSON.parse(localStorage.getItem(cacheName) || '{}');
    }
    catch (err) {
        localStorage.removeItem(cacheName);
        return {};
    }
};
var getLocalStorage = function (_a) {
    // there isn't state here now, but will be eventually
    var cacheLife = _a.cacheLife;
    var remove = function (name) { return __awaiter(void 0, void 0, void 0, function () {
        var cache;
        return __generator(this, function (_a) {
            cache = getCache();
            delete cache[name];
            localStorage.setItem(cacheName, JSON.stringify(cache));
            return [2 /*return*/];
        });
    }); };
    var has = function (responseID) { return __awaiter(void 0, void 0, void 0, function () {
        var cache;
        return __generator(this, function (_a) {
            cache = getCache();
            return [2 /*return*/, !!(cache[responseID] && cache[responseID].response)];
        });
    }); };
    var get = function (responseID) { return __awaiter(void 0, void 0, void 0, function () {
        var cache, _a, expiration, _b, body, headers, status, statusText;
        return __generator(this, function (_c) {
            cache = getCache();
            if (!cache[responseID]) {
                return [2 /*return*/];
            }
            _a = cache[responseID], expiration = _a.expiration, _b = _a.response, body = _b.body, headers = _b.headers, status = _b.status, statusText = _b.statusText;
            if (expiration < Date.now()) {
                delete cache[responseID];
                localStorage.setItem(cacheName, JSON.stringify(cache));
                return [2 /*return*/];
            }
            return [2 /*return*/, new Response(body, {
                    status: status,
                    statusText: statusText,
                    headers: new Headers(headers || {})
                })];
        });
    }); };
    var set = function (responseID, response) { return __awaiter(void 0, void 0, void 0, function () {
        var cache, responseObject;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    cache = getCache();
                    return [4 /*yield*/, utils_1.serializeResponse(response)];
                case 1:
                    responseObject = _a.sent();
                    cache[responseID] = {
                        response: responseObject,
                        expiration: Date.now() + cacheLife
                    };
                    localStorage.setItem(cacheName, JSON.stringify(cache));
                    return [2 /*return*/];
            }
        });
    }); };
    var clear = function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            localStorage.setItem(cacheName, JSON.stringify({}));
            return [2 /*return*/];
        });
    }); };
    return { get: get, set: set, has: has, delete: remove, clear: clear };
};
exports.default = getLocalStorage;
//# sourceMappingURL=localStorage.js.map